package interp

import "fmt"

func proc_expr(p *process_t) error {

	return nil
}

func proc_if(p *process_t) error {
	var (
		v   *string
		err error
	)

	if p.GetNumArgs() < 2 {
		err = err_num_args
		goto done
	}

	//v, err = p.interp.EvalText([]rune(*p.GetArg(0)))
	v, err = p.interp.eval_arg(p, 0)
	if err != nil {
		goto done
	}

	if *v != "" {
		//v, err = p.interp.eval_atom_node((*Cnode_t)(p.GetArg(1)))
		v, err = p.interp.eval_arg(p, 1)
		if err != nil {
			goto done
		}

		p.Return(*v)
	} else {
		// TODO: if elseif else
	}

done:
	return err
}

func proc_puts(p *process_t) error {
	var (
		i     int
		nargs int
		v     *string
		err   error
	)

	//fmt.Printf("callee=%s\n", *(p.GetCalleeName()))
	//fmt.Printf("callee=%s\n", *(p.GetArg(-1)))
	//fmt.Printf("arg count = %d\n", p.GetNumArgs())

	nargs = p.GetNumArgs()
	for i = 0; i < nargs; i++ {
		//fmt.Printf("%s", *p.GetArg(i))
		v, err = p.interp.eval_arg_literally(p, i)
		if err != nil {
			return err
		}
		fmt.Printf("%s", *v)
	}

	if nargs >= 1 {
		p.Return(*v)
	} else {
		p.Return("hello")
	}
	return nil
}

func proc_unknown(p *process_t) error {
	fmt.Printf("Unknown command - %s\n", *(p.GetCalleeName()))
	return nil
}
